Method

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.lang.reflect
Class Method

    java.lang.Object
      java.lang.reflect.AccessibleObject
          java.lang.reflect.Method

All Implemented Interfaces:
  Member

    public final class Method

extends AccessibleObject
implements Member

A `Method` provides information about, and access to, a single method on a class or interface. The reflected method may be a class method or an instance method (including an abstract method).

A `Method` permits widening conversions to occur when matching the actual parameters to invokewith the underlying method's formal parameters, but it throws an `IllegalArgumentException` if a narrowing conversion would occur.

Author:
  Nakul Saraiya
See Also:
  `Member`, `Class`, `Class.getMethods()`, `Class.getMethod(String, Class[])`, `Class.getDeclaredMethods()`, `Class.getDeclaredMethod(String, Class[])`

Field Summary

Fields inherited from interface java.lang.reflect.Member
`DECLARED, PUBLIC`

Method Summary
`boolean` | `equals(Object obj)` Compares this `Method` against the specified object.
`Class` | `getDeclaringClass()` Returns the `Class` object representing the class or interface that declares the method represented by this `Method` object.
`Class[]` | `getExceptionTypes()` Returns an array of `Class` objects that represent the types of the exceptions declared to be thrown by the underlying method represented by this `Method` object.
`int` | `getModifiers()` Returns the Java language modifiers for the method represented by this `Method` object, as an integer.
`String` | `getName()` Returns the name of the method represented by this `Method` object, as a `String`.
`Class[]` | `getParameterTypes()` Returns an array of `Class` objects that represent the formal parameter types, in declaration order, of the method represented by this `Method` object.
`Class` | `getReturnType()` Returns a `Class` object that represents the formal return type of the method represented by this `Method` object.
`int` | `hashCode()` Returns a hashcode for this `Method`.
`Object` | `invoke(Object obj, Object[] args)` Invokes the underlying method represented by this `Method` object, on the specified object with the specified parameters.
`String` | `toString()` Returns a string describing this `Method`.

Methods inherited from class java.lang.reflect.AccessibleObject
`isAccessible, setAccessible, setAccessible`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Method Detail

### getDeclaringClass

    public Class getDeclaringClass()

  Returns the `Class` object representing the class or interface that declares the method represented by this `Method` object.

  Specified by:
    `getDeclaringClass` in interface `Member`
  Returns:
    an object representing the declaring class of the underlying member

### getName

    public String getName()

  Returns the name of the method represented by this `Method` object, as a `String`.

  Specified by:
    `getName` in interface `Member`
  Returns:
    the simple name of the underlying member

### getModifiers

    public int getModifiers()

  Returns the Java language modifiers for the method represented by this `Method` object, as an integer. The `Modifier` class should be used to decode the modifiers.

  Specified by:
    `getModifiers` in interface `Member`
  Returns:
    the Java language modifiers for the underlying member
  See Also:
    `Modifier`

### getReturnType

    public Class getReturnType()

  Returns a `Class` object that represents the formal return type of the method represented by this `Method` object.

  Returns:
    the return type for the method this object represents

### getParameterTypes

    public Class[] getParameterTypes()

  Returns an array of `Class` objects that represent the formal parameter types, in declaration order, of the method represented by this `Method` object. Returns an array of length 0 if the underlying method takes no parameters.

  Returns:
    the parameter types for the method this object represents

### getExceptionTypes

    public Class[] getExceptionTypes()

  Returns an array of `Class` objects that represent the types of the exceptions declared to be thrown by the underlying method represented by this `Method` object. Returns an array of length 0 if the method declares no exceptions in its `throws` clause.

  Returns:
    the exception types declared as being thrown by the method this object represents

### equals

    public boolean equals(Object obj)

  Compares this `Method` against the specified object. Returns true if the objects are the same. Two `Methods` are the same if they were declared by the same class and have the same name and formal parameter types and return type.

  Overrides:
    `equals` in class `Object`
  Parameters:
    `obj` - the reference object with which to compare.
  Returns:
    `true` if this object is the same as the obj argument; `false` otherwise.
  See Also:
    `Object.hashCode()`, `Hashtable`

### hashCode

    public int hashCode()

  Returns a hashcode for this `Method`. The hashcode is computed as the exclusive-or of the hashcodes for the underlying method's declaring class name and the method's name.

  Overrides:
    `hashCode` in class `Object`
  Returns:
    a hash code value for this object.
  See Also:
    `Object.equals(java.lang.Object)`, `Hashtable`

### toString

    public String toString()

  Returns a string describing this `Method`. The string is formatted as the method access modifiers, if any, followed by the method return type, followed by a space, followed by the class declaring the method, followed by a period, followed by the method name, followed by a parenthesized, comma-separated list of the method's formal parameter types. If the method throws checked exceptions, the parameter list is followed by a space, followed by the word throws followed by a comma-separated list of the thrown exception types. For example:

          public boolean java.lang.Object.equals(java.lang.Object)

  The access modifiers are placed in canonical order as specified by "The Java Language Specification". This is `public`, `protected` or `private` first, and then other modifiers in the following order: `abstract`, `static`, `final`, `synchronized` `native`.

  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of the object.

### invoke

    public Object invoke(Object obj,
                         Object[] args)
                  throws IllegalAccessException,
                         IllegalArgumentException,
                         InvocationTargetException

  Invokes the underlying method represented by this `Method` object, on the specified object with the specified parameters. Individual parameters are automatically unwrapped to match primitive formal parameters, and both primitive and reference parameters are subject to method invocation conversions as necessary.

  If the underlying method is static, then the specified `obj` argument is ignored. It may be null.

  If the number of formal parameters required by the underlying method is 0, the supplied `args` array may be of length 0 or null.

  If the underlying method is an instance method, it is invoked using dynamic method lookup as documented in The Java Language Specification, Second Edition, section 15.12.4.4; in particular, overriding based on the runtime type of the target object will occur.

  If the underlying method is static, the class that declared the method is initialized if it has not already been initialized.

  If the method completes normally, the value it returns is returned to the caller of invoke; if the value has a primitive type, it is first appropriately wrapped in an object. If the underlying method return type is void, the invocation returns null.

  Parameters:
    `obj` - the object the underlying method is invoked from
    `args` - the arguments used for the method call
  Returns:
    the result of dispatching the method represented by this object on `obj` with parameters `args`
  Throws:
    `IllegalAccessException` - if this `Method` object enforces Java language access control and the underlying method is inaccessible.
    `IllegalArgumentException` - if the method is an instance method and the specified object argument is not an instance of the class or interface declaring the underlying method (or of a subclass or implementor thereof); if the number of actual and formal parameters differ; if an unwrapping conversion for primitive arguments fails; or if, after possible unwrapping, a parameter value cannot be converted to the corresponding formal parameter type by a method invocation conversion.
    `InvocationTargetException` - if the underlying method throws an exception.
    `NullPointerException` - if the specified object is null and the method is an instance method.
    `ExceptionInInitializerError` - if the initialization provoked by this method fails.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD